package io.github.null2264.tsukumogami.core.commands.converters

import io.github.null2264.tsukumogami.core.Context
import io.github.null2264.tsukumogami.core.commands.Argument
import io.github.null2264.tsukumogami.core.commands.Arguments
import kotlin.reflect.KProperty

abstract class Converter<OutputType: Any?> {

    open var isGreedy = false

    lateinit var argumentObj: Argument<OutputType>

    abstract var parsed: OutputType

    abstract suspend fun consume(context: Context, inputs: MutableList<String>): Boolean

    operator fun getValue(thisRef: Arguments, property: KProperty<*>): OutputType {
        return this.parsed
    }

    fun default(defaultValue: OutputType): OutputType {
        this.parsed = defaultValue
        return this.parsed
    }
}
