package io.github.null2264.tsukumogami.core.module

import io.github.null2264.tsukumogami.core.Bot
import io.github.null2264.tsukumogami.core.annotation.TsukumogamiInternalApi
import io.github.null2264.tsukumogami.core.commands.Command
import io.github.null2264.tsukumogami.core.commands.IGroup

@OptIn(TsukumogamiInternalApi::class)
open class BotModule constructor(val name: String) : IGroup {

    override val allCommands: MutableMap<String, Command> = mutableMapOf()

    override fun _addCommand(command: Command) {
        command.module = this
        super._addCommand(command)
    }

    internal fun install(bot: Bot): BotModule {
        allCommands.values.distinctBy { it.name }.forEach(bot::addCommand)
        return this
    }

    internal fun uninstall(bot: Bot): BotModule {
        allCommands.values.distinctBy { it.name }.forEach(bot::removeCommand)
        return this
    }
}
